Description

String#index and String#rindex yields different error messages when used with a Regexp argument:

'abc'.force_encoding("ISO-2022-JP").index(/わ/)

 Prints: incompatible character encodings: ISO-2022-JP and UTF-8 (Encoding::CompatibilityError)

'abc'.force_encoding("ISO-2022-JP").rindex(/わ/)

 Prints: incompatible encoding regexp match (UTF-8 regexp with ISO-2022-JP string) (Encoding::CompatibilityError)

Looking at a few other use cases (eg String#byteindex, String#byterindex) Ruby seems to use the message incompatible encoding

regexp match  when encoding is checked between a String and a Regexp instance. Is this a bug for String#index?

Associated revisions

Revision e2257831ab20915b839eeaff79c6ec45b498de77 - 07/09/2023 07:21 AM - nobu (Nobuyoshi Nakada)
Revision e2257831ab20915b839eeaff79c6ec45b498de77 - 07/09/2023 07:21 AM - nobu (Nobuyoshi Nakada)
Revision e2257831 - 07/09/2023 07:21 AM - nobu (Nobuyoshi Nakada)

[Bug #19763] Raise same message exception for regexp

History

#1 - 07/08/2023 05:20 PM - nobu (Nobuyoshi Nakada)

https://github.com/ruby/ruby/pull/8045

#2 - 07/09/2023 08:09 AM - nobu (Nobuyoshi Nakada)

- Status changed from Open to Closed

Applied in changeset git|e2257831ab20915b839eeaff79c6ec45b498de77.
